Loading...
Searching...
No Matches
wayland::pointer_t Class Reference

pointer input device More...

`#include <wayland-client-protocol.hpp>`

Inheritance diagram for wayland::pointer_t:
[legend]
Collaboration diagram for wayland::pointer_t:
[legend]

## Public Types

enum class | wrapper_type { standard , display , foreign , proxy_wrapper }

## Public Member Functions

void | set_cursor (uint32_t serial, surface_t const &surface, int32_t hotspot_x, int32_t hotspot_y)
| set the pointer surface
void | release ()
| release the pointer object
bool | can_release () const
| Check whether the release function is available with the currently bound version of the protocol.
std::function< void(uint32_t, surface_t, double, double)> & | on_enter ()
| enter event
std::function< void(uint32_t, surface_t)> & | on_leave ()
| leave event
std::function< void(uint32_t, double, double)> & | on_motion ()
| pointer motion event
std::function< void(uint32_t, uint32_t, uint32_t, pointer_button_state)> & | on_button ()
| pointer button event
std::function< void(uint32_t, pointer_axis, double)> & | on_axis ()
| axis event
std::function< void()> & | on_frame ()
| end of a pointer event sequence
std::function< void(pointer_axis_source)> & | on_axis_source ()
| axis source event
std::function< void(uint32_t, pointer_axis)> & | on_axis_stop ()
| axis stop event
std::function< void(pointer_axis, int32_t)> & | on_axis_discrete ()
| axis click event
std::function< void(pointer_axis, int32_t)> & | on_axis_value120 ()
| axis high-resolution scroll event
uint32_t | get_id () const
| Get the id of a proxy object.
std::string | get_class () const
| Get the interface name (class) of a proxy object.
uint32_t | get_version () const
| Get the protocol object version of a proxy object.
wrapper_type | get_wrapper_type () const
| Get the type of a proxy object.
void | set_queue (event_queue_t queue)
| Assign a proxy to an event queue.
wl_proxy * | c_ptr () const
| Get a pointer to the underlying C struct.
bool | proxy_has_object () const
| Check whether this wrapper actually wraps an object.
| operator bool () const
| Check whether this wrapper actually wraps an object.
bool | operator== (const proxy_t &right) const
| Check whether two wrappers refer to the same object.
bool | operator!= (const proxy_t &right) const
| Check whether two wrappers refer to different objects.
void | proxy_release ()
| Release the wrapped object (if any), making this an empty wrapper.

## Static Public Attributes

static constexpr std::uint32_t | set_cursor_since_version = 1
| Minimum protocol version required for the set_cursor function.
static constexpr std::uint32_t | release_since_version = 3
| Minimum protocol version required for the release function.

## Detailed Description

pointer input device

The wl_pointer interface represents one or more input devices, such as mice, which control the pointer location and pointer_focus of a seat.

The wl_pointer interface generates motion, enter and leave events for the surfaces that the pointer is located over, and button and axis events for button presses, button releases and scrolling.

Examples
  egl.cpp, and shm.cpp.

Definition at line 2689 of file wayland-client-protocol.hpp.

## Member Enumeration Documentation

## wrapper_type

enum class wayland::proxy_t::wrapper_type

strong inherited

Underlying wl_proxy type and properties of a proxy_t that affect construction, destruction, and event handling

Enumerator
standard | C pointer is a standard type compatible with wl_proxy*. Events are dispatched and it is destructed when the proxy_t is destructed. User data is set.
display | C pointer is a wl_display*. No events are dispatched, wl_display_disconnect is called when the proxy_t is destructed. User data is set.

foreign

C pointer is a standard type compatible with wl_proxy*, but another library owns it and it should not be touched in a way that could affect the operation of the other library. No events are dispatched, wl_proxy_destroy is not called when the proxy_t is destructed, user data is not touched. Consequently, there is no reference counting for the proxy_t. Lifetime of such wrappers should preferably be short to minimize the chance that the owning library decides to destroy the wl_proxy.

proxy_wrapper | C pointer is a wl_proxy* that was constructed with wl_proxy_create_wrapper. No events are dispatched, wl_proxy_wrapper_destroy is called when the proxy_t is destroyed. Reference counting is active. A reference to the proxy_t creating this proxy wrapper is held to extend its lifetime until after the proxy wrapper is destroyed.

Definition at line 117 of file wayland-client.hpp.

## Member Function Documentation

## c_ptr()

wl_proxy * wayland::proxy_t::c_ptr | ( |  | ) | const

inherited

Get a pointer to the underlying C struct.

Returns
  The underlying wl_proxy wrapped by this proxy_t if it exists, otherwise an exception is thrown

## can_release()

bool pointer_t::can_release | ( |  | ) | const

Check whether the release function is available with the currently bound version of the protocol.

Definition at line 2971 of file wayland-client-protocol.cpp.

## get_class()

std::string wayland::proxy_t::get_class | ( |  | ) | const

inherited

Get the interface name (class) of a proxy object.

Returns
  The interface name of the object associated with the proxy

## get_id()

uint32_t wayland::proxy_t::get_id | ( |  | ) | const

inherited

Get the id of a proxy object.

Returns
  The id the object associated with the proxy

## get_version()

uint32_t wayland::proxy_t::get_version | ( |  | ) | const

inherited

Get the protocol object version of a proxy object.

Gets the protocol object version of a proxy object, or 0 if the proxy was created with unversioned API.

A returned value of 0 means that no version information is available, so the caller must make safe assumptions about the object's real version.

display_t will always return version 0.

Returns
  The protocol object version of the proxy or 0

## get_wrapper_type()

wrapper_type wayland::proxy_t::get_wrapper_type | ( |  | ) | const

inline inherited

Get the type of a proxy object.

Definition at line 303 of file wayland-client.hpp.

## on_axis()

std::function< void(uint32_t, pointer_axis, double)> & pointer_t::on_axis | ( |  | ) |

axis event

Parameters

  time | timestamp with millisecond granularity
  axis | axis type
  value | length of vector in surface-local coordinate space

Scroll and other axis notifications.

For scroll events (vertical and horizontal scroll axes), the value parameter is the length of a vector along the specified axis in a coordinate space identical to those of motion events, representing a relative movement along the specified axis.

For devices that support movements non-parallel to axes multiple axis events will be emitted.

When applicable, for example for touch pads, the server can choose to emit scroll events where the motion vector is equivalent to a motion event vector.

When applicable, a client can transform its content relative to the scroll distance.

Definition at line 2997 of file wayland-client-protocol.cpp.

## on_axis_discrete()

std::function< void(pointer_axis, int32_t)> & pointer_t::on_axis_discrete | ( |  | ) |

axis click event

Parameters

  axis | axis type
  discrete | number of steps

Discrete step information for scroll and other axes.

This event carries the axis value of the wl_pointer.axis event in discrete steps (e.g. mouse wheel clicks).

This event is deprecated with wl_pointer version 8 - this event is not sent to clients supporting version 8 or later.

This event does not occur on its own, it is coupled with a wl_pointer.axis event that represents this axis value on a continuous scale. The protocol guarantees that each axis_discrete event is always followed by exactly one axis event with the same axis number within the same wl_pointer.frame. Note that the protocol allows for other events to occur between the axis_discrete and its coupled axis event, including other axis_discrete or axis events.

This event is optional; continuous scrolling devices like two-finger scrolling on touchpads do not have discrete steps and do not generate this event.

The discrete value carries the directional information. e.g. a value of -2 is two steps towards the negative direction of this axis.

The axis number is identical to the axis number in the associated axis event.

The order of wl_pointer.axis_discrete and wl_pointer.axis_source is not guaranteed.

Definition at line 3017 of file wayland-client-protocol.cpp.

## on_axis_source()

std::function< void(pointer_axis_source)> & pointer_t::on_axis_source | ( |  | ) |

axis source event

Parameters

  axis_source | source of the axis event

Source information for scroll and other axes.

This event does not occur on its own. It is sent before a wl_pointer.frame event and carries the source information for all events within that frame.

The source specifies how this event was generated. If the source is wl_pointer.axis_source.finger, a wl_pointer.axis_stop event will be sent when the user lifts the finger off the device.

If the source is wl_pointer.axis_source.wheel, wl_pointer.axis_source.wheel_tilt or wl_pointer.axis_source.continuous, a wl_pointer.axis_stop event may or may not be sent. Whether a compositor sends an axis_stop event for these sources is hardware-specific and implementation-dependent; clients must not rely on receiving an axis_stop event for these scroll sources and should treat scroll sequences from these scroll sources as unterminated by default.

This event is optional. If the source is unknown for a particular axis event sequence, no event is sent. Only one wl_pointer.axis_source event is permitted per frame.

The order of wl_pointer.axis_discrete and wl_pointer.axis_source is not guaranteed.

Definition at line 3007 of file wayland-client-protocol.cpp.

## on_axis_stop()

std::function< void(uint32_t, pointer_axis)> & pointer_t::on_axis_stop | ( |  | ) |

axis stop event

Parameters

  time | timestamp with millisecond granularity
  axis | the axis stopped with this event

Stop notification for scroll and other axes.

For some wl_pointer.axis_source types, a wl_pointer.axis_stop event is sent to notify a client that the axis sequence has terminated. This enables the client to implement kinetic scrolling. See the wl_pointer.axis_source documentation for information on when this event may be generated.

Any wl_pointer.axis events with the same axis_source after this event should be considered as the start of a new axis motion.

The timestamp is to be interpreted identical to the timestamp in the wl_pointer.axis event. The timestamp value may be the same as a preceding wl_pointer.axis event.

Definition at line 3012 of file wayland-client-protocol.cpp.

## on_axis_value120()

std::function< void(pointer_axis, int32_t)> & pointer_t::on_axis_value120 | ( |  | ) |

axis high-resolution scroll event

Parameters

  axis | axis type
  value120 | scroll distance as fraction of 120

Discrete high-resolution scroll information.

This event carries high-resolution wheel scroll information, with each multiple of 120 representing one logical scroll step (a wheel detent). For example, an axis_value120 of 30 is one quarter of a logical scroll step in the positive direction, a value120 of -240 are two logical scroll steps in the negative direction within the same hardware event. Clients that rely on discrete scrolling should accumulate the value120 to multiples of 120 before processing the event.

The value120 must not be zero.

This event replaces the wl_pointer.axis_discrete event in clients supporting wl_pointer version 8 or later.

Where a wl_pointer.axis_source event occurs in the same wl_pointer.frame, the axis source applies to this event.

The order of wl_pointer.axis_value120 and wl_pointer.axis_source is not guaranteed.

Definition at line 3022 of file wayland-client-protocol.cpp.

## on_button()

std::function< void(uint32_t, uint32_t, uint32_t, pointer_button_state)> & pointer_t::on_button | ( |  | ) |

pointer button event

Parameters

  serial | serial number of the button event
  time | timestamp with millisecond granularity
  button | button that produced the event
  state | physical state of the button

Mouse button click and release notifications.

The location of the click is given by the last motion or enter event. The time argument is a timestamp with millisecond granularity, with an undefined base.

The button is a button code as defined in the Linux kernel's linux/input-event-codes.h header file, e.g. BTN_LEFT.

Any 16-bit button code value is reserved for future additions to the kernel's event code list. All other button codes above 0xFFFF are currently undefined but may be used in future versions of this protocol.

Examples
  egl.cpp, and shm.cpp.

Definition at line 2992 of file wayland-client-protocol.cpp.

## on_enter()

std::function< void(uint32_t, surface_t, double, double)> & pointer_t::on_enter | ( |  | ) |

enter event

Parameters

  serial | serial number of the enter event
  surface | surface entered by the pointer
  surface_x | surface-local x coordinate
  surface_y | surface-local y coordinate

Notification that this seat's pointer is focused on a certain surface.

When a seat's focus enters a surface, the pointer image is undefined and a client should respond to this event by setting an appropriate pointer image with the set_cursor request.

Examples
  egl.cpp, and shm.cpp.

Definition at line 2977 of file wayland-client-protocol.cpp.

## on_frame()

std::function< void()> & pointer_t::on_frame | ( |  | ) |

end of a pointer event sequence

Indicates the end of a set of events that logically belong together. A client is expected to accumulate the data in all events within the frame before proceeding.

All wl_pointer events before a wl_pointer.frame event belong logically together. For example, in a diagonal scroll motion the compositor will send an optional wl_pointer.axis_source event, two wl_pointer.axis events (horizontal and vertical) and finally a wl_pointer.frame event. The client may use this information to calculate a diagonal vector for scrolling.

When multiple wl_pointer.axis events occur within the same frame, the motion vector is the combined motion of all events. When a wl_pointer.axis and a wl_pointer.axis_stop event occur within the same frame, this indicates that axis movement in one axis has stopped but continues in the other axis. When multiple wl_pointer.axis_stop events occur within the same frame, this indicates that these axes stopped in the same instance.

A wl_pointer.frame event is sent for every logical event group, even if the group only contains a single wl_pointer event. Specifically, a client may get a sequence: motion, frame, button, frame, axis, frame, axis_stop, frame.

The wl_pointer.enter and wl_pointer.leave events are logical events generated by the compositor and not the hardware. These events are also grouped by a wl_pointer.frame. When a pointer moves from one surface to another, a compositor should group the wl_pointer.leave event within the same wl_pointer.frame. However, a client must not rely on wl_pointer.leave and wl_pointer.enter being in the same wl_pointer.frame. Compositor-specific policies may require the wl_pointer.leave and wl_pointer.enter event being split across multiple wl_pointer.frame groups.

Definition at line 3002 of file wayland-client-protocol.cpp.

## on_leave()

std::function< void(uint32_t, surface_t)> & pointer_t::on_leave | ( |  | ) |

leave event

Parameters

  serial | serial number of the leave event
  surface | surface left by the pointer

Notification that this seat's pointer is no longer focused on a certain surface.

The leave notification is sent before the enter notification for the new focus.

Definition at line 2982 of file wayland-client-protocol.cpp.

## on_motion()

std::function< void(uint32_t, double, double)> & pointer_t::on_motion | ( |  | ) |

pointer motion event

Parameters

  time | timestamp with millisecond granularity
  surface_x | surface-local x coordinate
  surface_y | surface-local y coordinate

Notification of pointer location change. The arguments surface_x and surface_y are the location relative to the focused surface.

Definition at line 2987 of file wayland-client-protocol.cpp.

## operator bool()

wayland::proxy_t::operator bool | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## operator!=()

bool wayland::proxy_t::operator!= | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to different objects.

## operator==()

bool wayland::proxy_t::operator== | ( | const proxy_t & | right | ) | const

inherited

Check whether two wrappers refer to the same object.

## proxy_has_object()

bool wayland::proxy_t::proxy_has_object | ( |  | ) | const

inherited

Check whether this wrapper actually wraps an object.

Returns
  true if there is an underlying object, false if this wrapper is empty

## proxy_release()

void wayland::proxy_t::proxy_release | ( |  | ) |

inherited

Release the wrapped object (if any), making this an empty wrapper.

Note that display_t instances cannot be released this way. Attempts to do so are ignored.

Examples
  foreign_display.cpp.

## release()

void pointer_t::release | ( |  | ) |

release the pointer object

Using this request a client can tell the server that it is not going to use the pointer object anymore.

This request destroys the pointer proxy object, so clients must not call wl_pointer_destroy() after using this request.

Definition at line 2966 of file wayland-client-protocol.cpp.

## set_cursor()

void pointer_t::set_cursor | ( | uint32_t | serial,
|  | surface_t const & | surface,
|  | int32_t | hotspot_x,
|  | int32_t | hotspot_y
| ) |  |

set the pointer surface

Parameters

  serial | serial number of the enter event
  surface | pointer surface
  hotspot_x | surface-local x coordinate
  hotspot_y | surface-local y coordinate

Set the pointer surface, i.e., the surface that contains the pointer image (cursor). This request gives the surface the role of a cursor. If the surface already has another role, it raises a protocol error.

The cursor actually changes only if the pointer focus for this device is one of the requesting client's surfaces or the surface parameter is the current pointer surface. If there was a previous surface set with this request it is replaced. If surface is NULL, the pointer image is hidden.

The parameters hotspot_x and hotspot_y define the position of the pointer surface relative to the pointer location. Its top-left corner is always at (x, y) - (hotspot_x, hotspot_y), where (x, y) are the coordinates of the pointer location, in surface-local coordinates.

On surface.attach requests to the pointer surface, hotspot_x and hotspot_y are decremented by the x and y parameters passed to the request. Attach must be confirmed by wl_surface.commit as usual.

The hotspot can also be updated by passing the currently set pointer surface to this request with new values for hotspot_x and hotspot_y.

The current and pending input regions of the wl_surface are cleared, and wl_surface.set_input_region is ignored until the wl_surface is no longer used as the cursor. When the use as a cursor ends, the current and pending input regions become undefined, and the wl_surface is unmapped.

The serial parameter must match the latest wl_pointer.enter serial number sent to the client. Otherwise the request will be ignored.

Examples
  egl.cpp, and shm.cpp.

Definition at line 2960 of file wayland-client-protocol.cpp.

## set_queue()

void wayland::proxy_t::set_queue | ( | event_queue_t | queue | ) |

inherited

Assign a proxy to an event queue.

Parameters

  queue | The event queue that will handle this proxy

Assign proxy to event queue. Events coming from proxy will be queued in queue instead of the display's main queue.

See also: display_t::dispatch_queue().

Examples
  proxy_wrapper.cpp.

## Member Data Documentation

## release_since_version

constexpr std::uint32_t wayland::pointer_t::release_since_version = 3

static constexpr

Minimum protocol version required for the release function.

Definition at line 2783 of file wayland-client-protocol.hpp.

## set_cursor_since_version

constexpr std::uint32_t wayland::pointer_t::set_cursor_since_version = 1

static constexpr

Minimum protocol version required for the set_cursor function.

Definition at line 2768 of file wayland-client-protocol.hpp.

The documentation for this class was generated from the following files:

- obj-x86_64-linux-gnu/wayland-client-protocol.hpp
- obj-x86_64-linux-gnu/wayland-client-protocol.cpp
- obj-x86_64-linux-gnu/wayland-server-protocol.cpp